/* PragmaDev RTDS CMX integration */

/* List of errors returned by RTDS 'kernel' */

#define RTDS_ERROR_NO_MORE_TIMER_UNIQUE_ID						0x0001
#define RTDS_ERROR_MSG_Q_SEND_IN_WATCHDOG 						0x0002
#define RTDS_ERROR_MSG_QUEUE_SEND 										0x0006
#define RTDS_ERROR_MSG_INPUT													0x0007

#define RTDS_ERROR_MALLOC_TIMER_STATE_IN_START_TIMER	0x0008
#define RTDS_ERROR_TIMER_TO_STOP_NOT_FOUND						0x0009

#define RTDS_ERROR_TASK_DELETE												0x0010
#define RTDS_ERROR_MSG_QUEUE_DELETE 									0x0011

#define RTDS_ERROR_PROCESS_CREATE_MALLOC							0x0012
#define RTDS_ERROR_PROCESS_CREATE_MSG_Q_CREATE				0x0013
#define RTDS_ERROR_PROCESS_CREATE_TASK_SPAWN					0x0014

#define RTDS_ERROR_SEM_INFO_INSERT_MALLOC 						0x0015
#define RTDS_ERROR_SEM_INFO_INSERT										0x0016

#define RTDS_ERROR_GET_SEMAPHORE_ID 									0x0017 /* semaphore name not found */

#define RTDS_ERROR_TIMER_INCONSISTANT 								0x0022 /* parameters in the header are not consistant with a timer message */

#define RTDS_ERROR_GET_PROCESS_QUEUE_ID 							0x0023 /* process name not found */

#define RTDS_ERROR_STARTUP_CONTEXT_MALLOC 						0x0024 /* startup task could not allocate memory for current context */

#define RTDS_ERROR_TASK_TO_DELETE_NOT_FOUND 					0x0025 /* The task to delete was not found in the globalProcessInfoList */

#define RTDS_ERROR_NO_MORE_MSG_UNIQUE_ID							0x1001 /* No more message unique id available. Increase RTDS_MESSAGE_UNIQUE_ID_POOL_SIZE */
#define RTDS_ERROR_BACK_TRACE_NOT_ENOUGH_MEMORY 			0x1002 /* There is not enough memory to store all the events in RAM. Reduce RTDS_BACK_TRACE_MAX_EVENT_NUM or RTDS_BACK_TRACE_MESSAGE_DATA_SIZE */

/* Specific to CMX RTX integration */
#define RTDS_ERROR_MSG_QUEUE_GET											0x2001 /* No more CMX mailboxes available. Increase C_MAX_MAILBOXES... */
#define RTDS_ERROR_TASK_SLOT_ID_GET 									0x2002 /* No more unsigned char address available to store CMX task slot */
#define RTDS_ERROR_TASK_SLOT_ID_FREE									0x2003 /* Could not find the index of taskSlot in RTDS_globalTaskSlot array */
#define RTDS_ERROR_SEMAPHORE_GET											0x2004 /* No more CMX semaphores available. Increase C_MAX_SEMAPHORES... */
#define RTDS_ERROR_SEMAPHORE_ID_TAKE									0x2005 /* Error while trying to take the semaphore */
#define RTDS_ERROR_TIMER_EVENT_ID_GET 								0x2006 /* Maximum number of simultaneous timers reached (15) */
#define RTDS_ERROR_TIMER_CREATE 											0x2007 /* Timer creation did not work */
#define RTDS_ERROR_TIMER_START												0x2008 /* Timer start did not work */
#define RTDS_ERROR_MBOX_EVENT_SET 										0x2009 /* Association between message box and event did not work */
#define RTDS_ERROR_SEMAPHORE_CREATE 									0x2010 /* Error while trying to create the semaphore */
#define RTDS_ERROR_EVENT_RESET												0x2011	/* Problem while trying to reset a CMX event in RTDS_MsgQueueReceive function */
