#ifndef _RTDS_BASICLIST_H_
#define _RTDS_BASICLIST_H_

// Struct for list atom
struct  RTDS_ListAtom
{
  void                  *car;
  struct RTDS_ListAtom  *cdr;
};


// CLASS BASIC.LIST:
// =================
// List with void* elements

class RTDS_BasicList
  {
  
  // OPERATIONS:
  // -----------
  
  public:
  
    // Attribute for list length
    int length;
    
    // Constructor and destructor
    RTDS_BasicList();
    ~RTDS_BasicList();
    
    // append: adds an element to the list
    void append(void* e);
    
    // del: deletes an element from the list
    void del(int eltIndex);
    
    // Operator []: gets or sets an element in the list
    void*& operator[](int i);
  

  private:
    RTDS_ListAtom* firstElement;
    RTDS_ListAtom* lastElement;
  };

#endif
